import { Hono } from 'hono';

import { PostPage } from '@blog/templates/Pages/PostPage';
import { FourOhFour } from '@blog/templates/Pages/FourOhFour';
import { readdir } from 'node:fs/promises';
import { readPostMarkdown } from '@blog/util/readPostMarkdown';

const app = new Hono();

app.get('/posts/:slug', async (c) => {
  const postSlug: string = c.req.param("slug");
  const fileName: string = postSlug + '.md';
  const files = await readdir(__dirname + "/../posts");

  const postFile = files.find(f => f === fileName);
  if (!postFile) {
    c.status(404);
    return c.render(<FourOhFour />);
  }

  const post = await readPostMarkdown(__dirname + "/../posts/" + postFile);
  return c.render(<PostPage post={post} />);
});

export default app;

